/*

    util.c: a set of utility procedures I found useful when
	frobbing DOOM WADs
    Copyright (C) 1994  Robert H. Forsman Jr.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <ctype.h>
#include <string.h>
#include "wad.h"

FILE *fopen_b(char *fname, int forwrite, int binary)
{
    if (0==strcmp("-", fname)) {
	return forwrite ? stdout : stdin;
    } else {
	FILE	*rval;
	rval = fopen(fname, binary ? (forwrite ? "wb":"rb") : (forwrite ? "w":"r"));
	if (rval == 0) {
	    fprintf(stderr, "error opening file %s for %s : ", fname, forwrite?"write":"read");
	    perror("");
	    return 0;
	} else
	    return rval;
    }
}

void fclose_b(FILE *fp)
{
    if (fp!=stdin && fp!=stdout)
	fclose(fp);
}

void upcopy8(char *dst, char *src)
{
    int	i;
    for (i=0; i<8 && src[i]; i++)
	dst[i] = islower(src[i]) ? toupper(src[i]) : src[i];
    for ( ; i<8; i++)
	dst[i] = 0;
}

void write8(char *name, FILE *fp)
{
    int	i;
    for (i=0; i<8 && name[i]; i++)
	putc(name[i],fp);
}

void write_I16(int val, FILE *fp)
{
    INT16	tmp = htoIs(val);
    fwrite(&tmp, sizeof(tmp), 1, fp);
}

void write_I32(int val, FILE *fp)
{
    INT32	tmp = htoIl(val);
    fwrite(&tmp, sizeof(tmp), 1, fp);
}
